<?php

/*
 * Copyright (c) 2015, Leif Lindbäck
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions are 
 * met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright 
 *    notice, this list of conditions and the following disclaimer in the 
 *    documentation and/or other materials provided with the distribution.
 * 
 * 3. Neither the name of the copyright holder nor the names of its 
 *    contributors may be used to endorse or promote products derived from 
 *    this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS 
 * IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR 
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR 
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

//Specify path to directory where 'src' and 'test' directories are located.
define('PROJECT_HOME', '/home/leif/NetBeansProjects/id1354-fw/');

//Can not register autoloader, phpunit probably uses __autoload(). Lets include everything here!
//includeDir(PROJECT_HOME . "tests/classes/pathToThirdPartyLibrary");
includeDir(PROJECT_HOME . "tests/resources/classes");
includeDir(PROJECT_HOME . "classes");
include '/home/leif/vendor/autoload.php';

function includeDir($path) {
    foreach (\scandir($path) as $file) {
        $currPath = $path . '/' . $file;
        if (\is_dir($currPath) && $file != "." && $file != "..") {
            includeDir($currPath);
        } elseif (isClass($currPath, $file)) {
            require_once $currPath;
        }
    }
}

function isClass($path, $file) {
    if (!\is_file($path)) {
        return FALSE;
    }
    if (!endsWith($file, '.php')) {
        return FALSE;
    }
    if (\strcmp($file, \ucfirst($file)) !== 0) {
        return FALSE;
    }
    return TRUE;
}

function endsWith($str, $end) {
    return (\strcmp(\strstr($str, $end, TRUE) . $end, $str) === 0);
}
